/*
Copyright 2023.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	json "encoding/json"
	"fmt"
	"time"

	v1alpha1 "github.com/dapr/kubernetes-operator/api/operator/v1alpha1"
	operatorv1alpha1 "github.com/dapr/kubernetes-operator/pkg/client/applyconfiguration/operator/v1alpha1"
	scheme "github.com/dapr/kubernetes-operator/pkg/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// DaprControlPlanesGetter has a method to return a DaprControlPlaneInterface.
// A group's client should implement this interface.
type DaprControlPlanesGetter interface {
	DaprControlPlanes(namespace string) DaprControlPlaneInterface
}

// DaprControlPlaneInterface has methods to work with DaprControlPlane resources.
type DaprControlPlaneInterface interface {
	Create(ctx context.Context, daprControlPlane *v1alpha1.DaprControlPlane, opts v1.CreateOptions) (*v1alpha1.DaprControlPlane, error)
	Update(ctx context.Context, daprControlPlane *v1alpha1.DaprControlPlane, opts v1.UpdateOptions) (*v1alpha1.DaprControlPlane, error)
	UpdateStatus(ctx context.Context, daprControlPlane *v1alpha1.DaprControlPlane, opts v1.UpdateOptions) (*v1alpha1.DaprControlPlane, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.DaprControlPlane, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.DaprControlPlaneList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.DaprControlPlane, err error)
	Apply(ctx context.Context, daprControlPlane *operatorv1alpha1.DaprControlPlaneApplyConfiguration, opts v1.ApplyOptions) (result *v1alpha1.DaprControlPlane, err error)
	ApplyStatus(ctx context.Context, daprControlPlane *operatorv1alpha1.DaprControlPlaneApplyConfiguration, opts v1.ApplyOptions) (result *v1alpha1.DaprControlPlane, err error)
	DaprControlPlaneExpansion
}

// daprControlPlanes implements DaprControlPlaneInterface
type daprControlPlanes struct {
	client rest.Interface
	ns     string
}

// newDaprControlPlanes returns a DaprControlPlanes
func newDaprControlPlanes(c *OperatorV1alpha1Client, namespace string) *daprControlPlanes {
	return &daprControlPlanes{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the daprControlPlane, and returns the corresponding daprControlPlane object, and an error if there is any.
func (c *daprControlPlanes) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.DaprControlPlane, err error) {
	result = &v1alpha1.DaprControlPlane{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("daprcontrolplanes").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of DaprControlPlanes that match those selectors.
func (c *daprControlPlanes) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.DaprControlPlaneList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.DaprControlPlaneList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("daprcontrolplanes").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested daprControlPlanes.
func (c *daprControlPlanes) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("daprcontrolplanes").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a daprControlPlane and creates it.  Returns the server's representation of the daprControlPlane, and an error, if there is any.
func (c *daprControlPlanes) Create(ctx context.Context, daprControlPlane *v1alpha1.DaprControlPlane, opts v1.CreateOptions) (result *v1alpha1.DaprControlPlane, err error) {
	result = &v1alpha1.DaprControlPlane{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("daprcontrolplanes").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(daprControlPlane).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a daprControlPlane and updates it. Returns the server's representation of the daprControlPlane, and an error, if there is any.
func (c *daprControlPlanes) Update(ctx context.Context, daprControlPlane *v1alpha1.DaprControlPlane, opts v1.UpdateOptions) (result *v1alpha1.DaprControlPlane, err error) {
	result = &v1alpha1.DaprControlPlane{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("daprcontrolplanes").
		Name(daprControlPlane.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(daprControlPlane).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *daprControlPlanes) UpdateStatus(ctx context.Context, daprControlPlane *v1alpha1.DaprControlPlane, opts v1.UpdateOptions) (result *v1alpha1.DaprControlPlane, err error) {
	result = &v1alpha1.DaprControlPlane{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("daprcontrolplanes").
		Name(daprControlPlane.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(daprControlPlane).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the daprControlPlane and deletes it. Returns an error if one occurs.
func (c *daprControlPlanes) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("daprcontrolplanes").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *daprControlPlanes) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("daprcontrolplanes").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched daprControlPlane.
func (c *daprControlPlanes) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.DaprControlPlane, err error) {
	result = &v1alpha1.DaprControlPlane{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("daprcontrolplanes").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}

// Apply takes the given apply declarative configuration, applies it and returns the applied daprControlPlane.
func (c *daprControlPlanes) Apply(ctx context.Context, daprControlPlane *operatorv1alpha1.DaprControlPlaneApplyConfiguration, opts v1.ApplyOptions) (result *v1alpha1.DaprControlPlane, err error) {
	if daprControlPlane == nil {
		return nil, fmt.Errorf("daprControlPlane provided to Apply must not be nil")
	}
	patchOpts := opts.ToPatchOptions()
	data, err := json.Marshal(daprControlPlane)
	if err != nil {
		return nil, err
	}
	name := daprControlPlane.Name
	if name == nil {
		return nil, fmt.Errorf("daprControlPlane.Name must be provided to Apply")
	}
	result = &v1alpha1.DaprControlPlane{}
	err = c.client.Patch(types.ApplyPatchType).
		Namespace(c.ns).
		Resource("daprcontrolplanes").
		Name(*name).
		VersionedParams(&patchOpts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}

// ApplyStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating ApplyStatus().
func (c *daprControlPlanes) ApplyStatus(ctx context.Context, daprControlPlane *operatorv1alpha1.DaprControlPlaneApplyConfiguration, opts v1.ApplyOptions) (result *v1alpha1.DaprControlPlane, err error) {
	if daprControlPlane == nil {
		return nil, fmt.Errorf("daprControlPlane provided to Apply must not be nil")
	}
	patchOpts := opts.ToPatchOptions()
	data, err := json.Marshal(daprControlPlane)
	if err != nil {
		return nil, err
	}

	name := daprControlPlane.Name
	if name == nil {
		return nil, fmt.Errorf("daprControlPlane.Name must be provided to Apply")
	}

	result = &v1alpha1.DaprControlPlane{}
	err = c.client.Patch(types.ApplyPatchType).
		Namespace(c.ns).
		Resource("daprcontrolplanes").
		Name(*name).
		SubResource("status").
		VersionedParams(&patchOpts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
