/*
Copyright 2023.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	json "encoding/json"
	"fmt"
	"time"

	v1alpha1 "github.com/dapr/kubernetes-operator/api/operator/v1alpha1"
	operatorv1alpha1 "github.com/dapr/kubernetes-operator/pkg/client/applyconfiguration/operator/v1alpha1"
	scheme "github.com/dapr/kubernetes-operator/pkg/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// DaprCruiseControlsGetter has a method to return a DaprCruiseControlInterface.
// A group's client should implement this interface.
type DaprCruiseControlsGetter interface {
	DaprCruiseControls(namespace string) DaprCruiseControlInterface
}

// DaprCruiseControlInterface has methods to work with DaprCruiseControl resources.
type DaprCruiseControlInterface interface {
	Create(ctx context.Context, daprCruiseControl *v1alpha1.DaprCruiseControl, opts v1.CreateOptions) (*v1alpha1.DaprCruiseControl, error)
	Update(ctx context.Context, daprCruiseControl *v1alpha1.DaprCruiseControl, opts v1.UpdateOptions) (*v1alpha1.DaprCruiseControl, error)
	UpdateStatus(ctx context.Context, daprCruiseControl *v1alpha1.DaprCruiseControl, opts v1.UpdateOptions) (*v1alpha1.DaprCruiseControl, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.DaprCruiseControl, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.DaprCruiseControlList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.DaprCruiseControl, err error)
	Apply(ctx context.Context, daprCruiseControl *operatorv1alpha1.DaprCruiseControlApplyConfiguration, opts v1.ApplyOptions) (result *v1alpha1.DaprCruiseControl, err error)
	ApplyStatus(ctx context.Context, daprCruiseControl *operatorv1alpha1.DaprCruiseControlApplyConfiguration, opts v1.ApplyOptions) (result *v1alpha1.DaprCruiseControl, err error)
	DaprCruiseControlExpansion
}

// daprCruiseControls implements DaprCruiseControlInterface
type daprCruiseControls struct {
	client rest.Interface
	ns     string
}

// newDaprCruiseControls returns a DaprCruiseControls
func newDaprCruiseControls(c *OperatorV1alpha1Client, namespace string) *daprCruiseControls {
	return &daprCruiseControls{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the daprCruiseControl, and returns the corresponding daprCruiseControl object, and an error if there is any.
func (c *daprCruiseControls) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.DaprCruiseControl, err error) {
	result = &v1alpha1.DaprCruiseControl{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("daprcruisecontrols").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of DaprCruiseControls that match those selectors.
func (c *daprCruiseControls) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.DaprCruiseControlList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.DaprCruiseControlList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("daprcruisecontrols").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested daprCruiseControls.
func (c *daprCruiseControls) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("daprcruisecontrols").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a daprCruiseControl and creates it.  Returns the server's representation of the daprCruiseControl, and an error, if there is any.
func (c *daprCruiseControls) Create(ctx context.Context, daprCruiseControl *v1alpha1.DaprCruiseControl, opts v1.CreateOptions) (result *v1alpha1.DaprCruiseControl, err error) {
	result = &v1alpha1.DaprCruiseControl{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("daprcruisecontrols").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(daprCruiseControl).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a daprCruiseControl and updates it. Returns the server's representation of the daprCruiseControl, and an error, if there is any.
func (c *daprCruiseControls) Update(ctx context.Context, daprCruiseControl *v1alpha1.DaprCruiseControl, opts v1.UpdateOptions) (result *v1alpha1.DaprCruiseControl, err error) {
	result = &v1alpha1.DaprCruiseControl{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("daprcruisecontrols").
		Name(daprCruiseControl.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(daprCruiseControl).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *daprCruiseControls) UpdateStatus(ctx context.Context, daprCruiseControl *v1alpha1.DaprCruiseControl, opts v1.UpdateOptions) (result *v1alpha1.DaprCruiseControl, err error) {
	result = &v1alpha1.DaprCruiseControl{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("daprcruisecontrols").
		Name(daprCruiseControl.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(daprCruiseControl).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the daprCruiseControl and deletes it. Returns an error if one occurs.
func (c *daprCruiseControls) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("daprcruisecontrols").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *daprCruiseControls) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("daprcruisecontrols").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched daprCruiseControl.
func (c *daprCruiseControls) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.DaprCruiseControl, err error) {
	result = &v1alpha1.DaprCruiseControl{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("daprcruisecontrols").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}

// Apply takes the given apply declarative configuration, applies it and returns the applied daprCruiseControl.
func (c *daprCruiseControls) Apply(ctx context.Context, daprCruiseControl *operatorv1alpha1.DaprCruiseControlApplyConfiguration, opts v1.ApplyOptions) (result *v1alpha1.DaprCruiseControl, err error) {
	if daprCruiseControl == nil {
		return nil, fmt.Errorf("daprCruiseControl provided to Apply must not be nil")
	}
	patchOpts := opts.ToPatchOptions()
	data, err := json.Marshal(daprCruiseControl)
	if err != nil {
		return nil, err
	}
	name := daprCruiseControl.Name
	if name == nil {
		return nil, fmt.Errorf("daprCruiseControl.Name must be provided to Apply")
	}
	result = &v1alpha1.DaprCruiseControl{}
	err = c.client.Patch(types.ApplyPatchType).
		Namespace(c.ns).
		Resource("daprcruisecontrols").
		Name(*name).
		VersionedParams(&patchOpts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}

// ApplyStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating ApplyStatus().
func (c *daprCruiseControls) ApplyStatus(ctx context.Context, daprCruiseControl *operatorv1alpha1.DaprCruiseControlApplyConfiguration, opts v1.ApplyOptions) (result *v1alpha1.DaprCruiseControl, err error) {
	if daprCruiseControl == nil {
		return nil, fmt.Errorf("daprCruiseControl provided to Apply must not be nil")
	}
	patchOpts := opts.ToPatchOptions()
	data, err := json.Marshal(daprCruiseControl)
	if err != nil {
		return nil, err
	}

	name := daprCruiseControl.Name
	if name == nil {
		return nil, fmt.Errorf("daprCruiseControl.Name must be provided to Apply")
	}

	result = &v1alpha1.DaprCruiseControl{}
	err = c.client.Patch(types.ApplyPatchType).
		Namespace(c.ns).
		Resource("daprcruisecontrols").
		Name(*name).
		SubResource("status").
		VersionedParams(&patchOpts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
